
#include "g_local.h"
char *getClassName (gclient_t *c);
void Cmd_Classdef_f (); 
//int SaveClassInfo();
void Adm_Test(char *cmd);
void CTFResetFlags(void);


//Show all the players
void sv_ShowPlayers()
{
//	edict_t		*cl_ent;
//	gclient_t	*cl;
	edict_t	*e;

	int i;

	//Show red players first
	for (i=1, e=g_edicts+i; i < globals.num_edicts; i++,e++)
	{
		if (!e->inuse)
			continue;
		if (!e->client)
			continue;
		//getClassName(e->client, classname);
		if (e->client->resp.ctf_team == CTF_TEAM1)
		{
			gi.dprintf ("Red  %3d %8s %s\n",
				e->client->resp.score,
				getClassName(e->client),
				e->client->pers.netname);
		}
	}

	//Next blue
	for (i=1, e=g_edicts+i; i < globals.num_edicts; i++,e++)
	{
		if (!e->inuse)
			continue;
		if (!e->client)
			continue;
		//getClassName(e->client, classname);
		if (e->client->resp.ctf_team == CTF_TEAM2)
		{
			gi.dprintf ("Blue %3d %8s %s\n",
				e->client->resp.score,
				getClassName(e->client),
				e->client->pers.netname);
		}
	}

	//Then observers
	for (i=1, e=g_edicts+i; i < globals.num_edicts; i++,e++)
	{
		if (!e->inuse)
			continue;
		if (!e->client)
			continue;
		//getClassName(e->client, classname);
		if (e->client->resp.ctf_team <= 0)
		{
			gi.dprintf ("Obsv %3d %8s %s\n",
				e->client->resp.score,
				getClassName(e->client),
				e->client->pers.netname);
		}
	}
}


/*
=================
ServerCommand

ServerCommand will be called when an "sv" command is issued.
The game can issue gi.argc() / gi.argv() commands to get the rest
of the parameters
=================
*/
void SV_WFFlags_f ();

void	ServerCommand (void)
{
	char	*cmd;
	char	*arg1;

	cmd = gi.argv(1);
	arg1 = gi.argv(2);

	if (Q_stricmp (cmd, "showplayers") == 0)
	{
		sv_ShowPlayers ();
	}

    else if (Q_stricmp (cmd, "maplist") == 0) 
    { 
        Cmd_Maplist_f (NULL); 
	}
	
    else if (Q_stricmp (cmd, "classdef") == 0) 
    { 
        Cmd_Classdef_f (NULL); 
	}

    else if (Q_stricmp (cmd, "wfflags") == 0) 
    { 
        SV_WFFlags_f (); 
	}  

    else if (Q_stricmp (cmd, "resetflags") == 0) 
    { 
        CTFResetFlags(); 
	}  

    else if (Q_stricmp (cmd, "addip") == 0) 
    { 
		Adm_Ban(arg1);
		//	Adm_KickBan(edict_t *ent);
	}  

    else if (Q_stricmp (cmd, "testip") == 0) 
    { 
		Adm_Test(arg1);
		//	Adm_KickBan(edict_t *ent);
	}  
    else if (Q_stricmp (cmd, "listip") == 0) 
    { 
		Adm_Bans(arg1);
	}  

    else if (Q_stricmp (cmd, "writeip") == 0) 
    { 
		WriteBans();
	}  

    else if (Q_stricmp (cmd, "removeip") == 0) 
    { 
		Adm_Unban(arg1);
	}  

    else if (Q_stricmp (cmd, "debug") == 0) 
    { 
		wfdebug = 1;
		gi.dprintf("WF Debug On\n");
	}  

    else if (Q_stricmp (cmd, "nodebug") == 0) 
    { 
		wfdebug = 1;
		gi.dprintf("WF Debug Off\n");
	}  

	else
		gi.dprintf ("Unknown server command \"%s\"\n", cmd);
}

